# pylint:
"""
Django settings for strapper project.

Generated by 'django-admin startproject' using Django 4.1.1.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

from pathlib import Path
import os
import collections
import environ
from .config import determine_config

# Django nose needs this
collections.Callable = collections.abc.Callable

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Change the line below if need to specify the path of .env file
# For example: environ.Env.read_env(os.path.join(BASE_DIR, '.env'))
environ.Env.read_env()

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY', 'supersecretkey')

# Temporarily disable Cross Origin Opener Policy
SECURE_CROSS_ORIGIN_OPENER_POLICY = None

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG') == 'true'

# SECURITY WARNING: This attribute allows the hosts listed to host the django project.
# In production, only allow hosts that you want to host your project.
# In development, default already includes "locahost" and "127.0.0.1"
ALLOWED_HOSTS = ['*']
if hosts_str := os.environ.get('ALLOWED_HOSTS'):
    ALLOWED_HOSTS = [
        host.strip()
        for host in hosts_str.split(',')
        if host.strip()
    ]

CSRF_TRUSTED_ORIGINS = []
if origins_str := os.environ.get('CSRF_TRUSTED_ORIGINS'):
    CSRF_TRUSTED_ORIGINS = [
        origin.strip()
        for origin in origins_str.split(',')
        if origin.strip()
    ]

# Configuration for development ONLY
CONFIG = determine_config(BASE_DIR / 'instance')

# Set up this configs based on your need
CONFIG['PROJECT_TITLE'] = "Strapper"
CONFIG['PROJECT_HOMEPAGE'] = 'https://gitlab.com/uvic-arcsoft/strap/strapper'
# Disable line-too-long C0301 as this string cannot be separated
# into multiple lines because it is rendered as html in the base template
# pylint: disable-next=C0301
CONFIG['ABOUT_CONTENT'] = """
    <p>Portal to STRAP, an opinionated application platform built on Kubernetes and other open-source technologies.</p>
    <ul>
        <li><a href="https://arcsoft.uvic.ca/projects/strap/">Project home page</a></li>
        <li><a href="https://gitlab.com/uvic-arcsoft/strap/">Source code</a></li>
    </ul>
"""
CONFIG['AUTHX_HTTP_HEADER_USER'] = 'X-Forwarded-User'
CONFIG['AUTHX_HTTP_HEADER_ID_TOKEN'] = 'X-Forwarded-Id-Token'

# Authenticate with a fake username
if os.environ.get('AUTHX_USER_OVERRIDE', None):
    CONFIG['AUTHX_USER_OVERRIDE'] = os.environ.get('AUTHX_USER_OVERRIDE', 'admin@example.org')

if DEBUG:
    # Users will be created for this app from usernames specified here
    # Specify the usernames, and run 'make create_users' or 'python3 manage.py createusers'
    # The default password for all normal users is 'testinguser', for all admin users is 'testingadmin'.
    # Run 'python manage.py changepassword [<username>] to change password for users'.
    CONFIG['AUTHZ_USERS'] = ['user@example.org', 'user1@example.org']
    CONFIG['AUTHZ_ADMINS'] = ['admin1@example.org', 'admin2@example.org']

# Directory to store all Terraform logs
TERRAFORM_DIR = "/tmp/terraform"

# List all the names of editable content texts that are accessible to all pages in the app
GLOBAL_EDITABLE_CONTENTS_NAMES = ['about_text']

# This value is overriden to True in unit tests
TESTING = False

# This value is overriden to True in editablecontent and fileupload app's unit tests
EDITABLECONTENT_TESTING = False

# Time out for Terraform processes
TERRAFORM_TIMEOUT = 310

# Automatically append slash to the end of URLs
APPEND_SLASH = True

# Application definition
INSTALLED_APPS = [
    'daphne',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'normal_users',
    'admin_users',
    'help',
    'wizard',
    'channels',
    "django_editablecontent",
    "django_fileupload",
    "access"
]

# Only add django_nose if we are running tests
if os.environ.get("DJANGO_TEST"):
    INSTALLED_APPS.append('django_nose')


# Use nose to run all tests
TEST_RUNNER = 'django_nose.NoseTestSuiteRunner'

# Tell nose to measure coverage on the 'foo' and 'bar' apps
NOSE_ARGS = [
    '--with-coverage',
    '--cover-package=normal_users,strapper,admin_users,wizard,access,help',
    '--nologcapture',
    '--cover-html',
    '--cover-html-dir=strapper/unit_tests/coverage'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'middleware.block_external_urls_middleware.BlockExternalUrlsMiddleware',
    'middleware.authenticate_middleware.StarterAuthenticateMiddleware',
    'middleware.wizard_middleware.WizardMiddleware',
]

ROOT_URLCONF = 'strapper.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'strapper.custom_contexts.get_user',
                'strapper.custom_contexts.project_setup'
            ],
        },
    },
]

WSGI_APPLICATION = 'strapper.wsgi.application'

ASGI_APPLICATION = "strapper.asgi.application"
# CHANNEL_LAYERS = {
#     "default": {
#         "BACKEND": "channels_redis.core.RedisChannelLayer",
#         "CONFIG": {
#             "hosts": [(os.environ.get('REDIS_HOST'), 6379)],
#         },
#     },
# }

CHANNEL_LAYERS = {
    "default": {
        "BACKEND": "channels.layers.InMemoryChannelLayer"
    }
}

# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

# Testing with psql container ran on amalthea
# Enable this for deployment
if 'POSTGRES_HOST' in os.environ:
    default_db = {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': os.environ.get('POSTGRES_DB', 'strapper'),
        'USER': os.environ.get('POSTGRES_USER', 'postgres'),
        'PASSWORD': os.environ.get('POSTGRES_PASSWORD', 'testpassword'),
        'HOST': os.environ.get('POSTGRES_HOST', 'localhost')
    }
else:
    default_db = {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': 'strapper.sqlite3'
    }
DATABASES = {
    'default': default_db
}


# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'PST8PDT'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/
# Project looks for static file under "static" folder from the root directory
STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR.parent, 'static')
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static/"),
]

# Media files (images, pdf)
MEDIA_URL = '/media/'
if DEBUG or TESTING or EDITABLECONTENT_TESTING:
    MEDIA_ROOT = os.path.join(BASE_DIR.parent, 'media')
else:
    STORAGES = {
        "default": {
            "BACKEND": "storages.backends.s3.S3Storage",
            "OPTIONS": {
                "access_key": os.environ.get('MEDIA_FILE_ACCESS_KEY_ID'),
                "secret_key": os.environ.get('MEDIA_FILE_SECRET_ACCESS_KEY'),
                "bucket_name": os.environ.get('MEDIA_FILE_BUCKET'),
                "region_name": os.environ.get('MEDIA_FILE_REGION'),
                "endpoint_url": os.environ.get('MEDIA_FILE_ENDPOINT_URL_S3'),
                "use_ssl": True, 
                # "verify": os.environ.get('MEDIA_FILE_S3_VERIFY')
            },
        },
        "staticfiles": {
            "BACKEND": "django.contrib.staticfiles.storage.StaticFilesStorage",
        }
    }

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field
DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

# Email settings
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
EMAIL_HOST = os.environ.get('EMAIL_HOST', 'smtp.gmail.com')
EMAIL_PORT = os.environ.get('EMAIL_PORT', 587)
EMAIL_USE_TLS = os.environ.get('EMAIL_USE_TLS', True)
EMAIL_HOST_USER = os.environ.get('EMAIL_HOST_USER', None)
EMAIL_HOST_PASSWORD = os.environ.get('EMAIL_HOST_PASSWORD', 'youremailpassword')
